scaniaLifter = {};

function scaniaLifter.prerequisitesPresent(specializations)
    return true;
end;

function scaniaLifter:load(savegamme)
	self.isSelectable = true;
	self.toggle = SpecializationUtil.callSpecializationsFunction("toggle");
	self.animParts = {};
	self.sl = {};
	self.sl.attached = false
	self.sl.tippingOn = false
	self.sl.infoText = ""
	self.sl.debug = true
	local c = 0;
	while true do
		local baseString = string.format("vehicle.animParts.animPart(%d)#",c);
		local index = getXMLString(self.xmlFile,baseString.."index");
		local id = getXMLString(self.xmlFile,baseString.."id");
		local listenTo = getXMLString(self.xmlFile,baseString.."listenTo");
		if index == nil or id == nil or (InputBinding[id] == nil and listenTo == nil) then
			break;
		end;
		local part = {};
		part.index = Utils.indexToObject(self.components, index);
		part.id = id;
		part.listenTo = listenTo;
		
		local rotMin = getXMLString(self.xmlFile,baseString.."rotMin");
		local rotMax = getXMLString(self.xmlFile,baseString.."rotMax");
		if rotMin ~= nil and rotMax ~= nil then
			local x,y,z = Utils.getVectorFromString(rotMin);
			part.rotMin = {math.rad(Utils.getNoNil(x,0)),math.rad(Utils.getNoNil(y,0)),math.rad(Utils.getNoNil(z,0))};
			local x,y,z = Utils.getVectorFromString(rotMax);
			part.rotMax = {math.rad(Utils.getNoNil(x,0)),math.rad(Utils.getNoNil(y,0)),math.rad(Utils.getNoNil(z,0))};
		end;
		
		local transMin = getXMLString(self.xmlFile,baseString.."transMin");
		local transMax = getXMLString(self.xmlFile,baseString.."transMax");
		if transMin ~= nil and transMax ~= nil then
			local x,y,z = Utils.getVectorFromString(transMin);
			part.transMin = {Utils.getNoNil(x,0),Utils.getNoNil(y,0),Utils.getNoNil(z,0)};
			local x,y,z = Utils.getVectorFromString(transMax);
			part.transMax = {Utils.getNoNil(x,0),Utils.getNoNil(y,0),Utils.getNoNil(z,0)};
		end;
		
		local scaleMin = getXMLString(self.xmlFile,baseString.."scaleMin");
		local scaleMax = getXMLString(self.xmlFile,baseString.."scaleMax");
		if scaleMin ~= nil and scaleMax ~= nil then
			local x,y,z = Utils.getVectorFromString(scaleMin);
			part.scaleMin = {Utils.getNoNil(x,1),Utils.getNoNil(y,1),Utils.getNoNil(z,1)};
			local x,y,z = Utils.getVectorFromString(scaleMax);
			part.scaleMax = {Utils.getNoNil(x,1),Utils.getNoNil(y,1),Utils.getNoNil(z,1)};
		end;
		
		local permRotAxis = getXMLInt(self.xmlFile,baseString.."permRotAxis");
		if permRotAxis ~= nil then
			if permRotAxis >= 1 and permRotAxis <= 3 then
				part.permRotAxis = permRotAxis;
			end;
		end;
		
		part.moveTime = Utils.getNoNil(getXMLFloat(self.xmlFile,baseString.."moveTime"),1)*1000;
		part.helpText = Utils.getNoNil(getXMLBool(self.xmlFile, baseString.."showHelp"),false);
		part.autoReturn = Utils.getNoNil(getXMLBool(self.xmlFile, baseString.."autoReturn"),false);
		part.isMovingTool = Utils.getNoNil(getXMLBool(self.xmlFile, baseString.."isMovingTool"),false);
		part.toMax = false;
		part.move = false;
		table.insert(self.animParts,part);
		c=c+1;
	end;
end;

function scaniaLifter:delete()
end;

function scaniaLifter:mouseEvent(posX, posY, isDown, isUp, button)
end;

function scaniaLifter:keyEvent(unicode, sym, modifier, isDown)
end;

function scaniaLifter:update(dt)
	if self:getIsActive() then
		self.sl.lifter = nil
		self.sl.lifter2 = nil
		if self.attachedImplements[1] ~= nil and self.attachedImplements[1] ~= 0 then
			if self.attachedImplements[1].object ~= nil then
				self.sl.attached = true
				local attachedTrailer = self.attachedImplements[1].object
				if attachedTrailer.tipState == Trailer.TIPSTATE_OPENING or attachedTrailer.tipState == Trailer.TIPSTATE_OPEN then
					self.sl.tippingOn = true
				else
					self.sl.tippingOn = false
				end
				if attachedTrailer.tipAnimations ~= nil then
					for _, tipAnimation in pairs(attachedTrailer.tipAnimations) do
							if tipAnimation.tipEffect ~= nil then
								for _, tipEffect in pairs(tipAnimation.tipEffect) do
									if tipEffect ~= nil then
										self.sl.lifter2 = tipEffect.node
										if tipEffect.origRot == nil then
											local x,y,z = getRotation(tipEffect.node)
											tipEffect.origRot = {x,y,z}
										end
										if self.sl.tippingOn == true then
											local x,y,z = getWorldRotation(tipEffect.node)
											local xl,yl,zl = getRotation(tipEffect.node)
											local diffX = math.abs(x) - math.abs(z)
											local move = false
											if math.abs(diffX) > 0.01 then
												if x > 0.01 and x < math.pi then
													xl = xl - (0.5 * diffX)
												elseif x < -0.01 and x > -math.pi then
													xl = xl + (0.5 * diffX)
												end
												move = true
											end
											if move == true then
												setRotation(tipEffect.node, xl,yl,zl);
											end
										else
											setRotation(tipEffect.node,tipEffect.origRot[1],tipEffect.origRot[2],tipEffect.origRot[3]);
										end
									end
								end
							end
					end
				end
				if attachedTrailer.tipReferencePoints ~= nil then
					for _, tipReferencePoint in pairs(attachedTrailer.tipReferencePoints) do
						if tipReferencePoint.node ~= nil then
							self.sl.lifter = tipReferencePoint.node
							local x,y,z = getTranslation(tipReferencePoint.node)
							if tipReferencePoint.origPos == nil then
								tipReferencePoint.origPos = {x,y,z}
							end
							if self.sl.tippingOn == true and attachedTrailer ~= g_currentMission.trailerInTipRange then
								if z > (tipReferencePoint.origPos[3]-4) then
									z = z - 0.004
								end
								setTranslation(tipReferencePoint.node, x,y,z)
							else
								setTranslation(tipReferencePoint.node,tipReferencePoint.origPos[1],tipReferencePoint.origPos[2],tipReferencePoint.origPos[3]);
							end
						end
					end
				end
				self.sl.attached = true
			end
		else
			self.sl.attached = false
			self.sl.tippingOn = false
		end
		for nr,part in ipairs(self.animParts) do
			if not part.autoReturn then
				if InputBinding.hasEvent(InputBinding[part.id]) then
					self:toggle(nr,not part.toMax); 
				end;
				if self.sl.attached == true then
					if self.sl.tippingOn == true then
						if not part.toMax then
							self:toggle(nr,true); 
						end;
					else
						if part.toMax then
							self:toggle(nr,false); 
						end;
					end;
				end
			else
				if InputBinding.isPressed(InputBinding[part.id]) then
					if not part.toMax then
						self:toggle(nr,true); 
					end;
				else
					if part.toMax then
						self:toggle(nr,false); 
					end;
				end;
			end;
		end;
	end;
	if self:getIsActive() then
		for _,part in ipairs(self.animParts) do
			if part.listenTo ~= nil then
				if self[part.listenTo] then
					part.toMax = true;
					part.move = true;
				else
					part.toMax = false;
				end;
			end;
				
			if part.move then
				part.move = false;
				if part.rotMin ~= nil then
					local curRot = {getRotation(part.index)};
					local newRot = Utils.getMovedLimitedValues(curRot, part.rotMax, part.rotMin, 3, part.moveTime, dt, not part.toMax);
					setRotation(part.index, unpack(newRot));
					for i=1,3 do
						if math.abs(newRot[i]-curRot[i]) > 0.001 then
							part.move = true;
						end;
					end;
				end;
				if part.transMin ~= nil then
					local curTrans = {getTranslation(part.index)};
					local newTrans = Utils.getMovedLimitedValues(curTrans, part.transMax, part.transMin, 3, part.moveTime, dt, not part.toMax);
					setTranslation(part.index, unpack(newTrans));
					for i=1,3 do
						if math.abs(newTrans[i]-curTrans[i]) > 0.001 then
							part.move = true;
						end;
					end;
				end;
				if part.scaleMin ~= nil then
					local curScale = {getScale(part.index)};
					local newScale = Utils.getMovedLimitedValues(curScale, part.scaleMax, part.scaleMin, 3, part.moveTime, dt, not part.toMax);
					setScale(part.index, unpack(newScale));
					for i=1,3 do
						if math.abs(newScale[i]-curScale[i]) > 0.001 then
							part.move = true;
						end;
					end;
				end;
				if part.permRotAxis ~= nil then
					local spd = ((2*math.pi) / part.moveTime) * dt;
					local newRot = {0,0,0};
					newRot[part.permRotAxis] = spd;
					rotate(part.index, unpack(newRot));
					part.move = part.toMax;
				end;
				if part.isMovingTool then
					self:setMovingToolDirty(part.index);
				end;
			end;
		end;
	end;
end;

function scaniaLifter:updateTick(dt)
end;

function scaniaLifter:draw()
	if self:getIsActiveForInput() then
		for _,part in ipairs(self.animParts) do
			if part.helpText then
				g_currentMission:addHelpButtonText(g_i18n:getText(part.id), InputBinding[part.id]);
			end;
		end;
	end;
end;

function scaniaLifter:toggle(id,state,nes)
	scaniaLifterEvent.sendEvent(self,id,state,nes);
	self.animParts[id].toMax = state;
	self.animParts[id].move = true;
end;

function scaniaLifter:readStream(streamId, connection)
	for nr,part in ipairs(self.animParts) do
		local state = streamReadBool(streamId);
		self:toggle(nr,state,true);
	end;
end;
		
	
function scaniaLifter:writeStream(streamId, connection)
	for nr,part in ipairs(self.animParts) do
		streamWriteBool(streamId,part.toMax);
	end;
end;

scaniaLifterEvent = {};
scaniaLifterEvent_mt = Class(scaniaLifterEvent, Event);
InitEventClass(scaniaLifterEvent, "scaniaLifterEvent");

function scaniaLifterEvent:emptyNew()
    local self = Event:new(scaniaLifterEvent_mt);
    self.className="scaniaLifterEvent";
    return self;
end;

function scaniaLifterEvent:new(object, id, state)
		local self = scaniaLifterEvent:emptyNew()
		self.object = object;
		self.id = id;
		self.state = state;
		return self;
end;

function scaniaLifterEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
		self.id  = streamReadInt8(streamId);
    self.state = streamReadBool(streamId);
    self:run(connection);
end;

function scaniaLifterEvent:writeStream(streamId, connection)
    		streamWriteInt32(streamId, networkGetObjectId(self.object));
		streamWriteInt8(streamId, self.id);
		streamWriteBool(streamId, self.state);
end;

function scaniaLifterEvent:run(connection)
	self.object:toggle(self.id,self.state, true);
  if not connection:getIsServer() then
      g_server:broadcastEvent(scaniaLifterEvent:new(self.object, self.id, self.state), nil, connection, self.object);
  end;	
end;

function scaniaLifterEvent.sendEvent(vehicle, id, state, nes)
	if nes == nil or nes == false then
		if g_server ~= nil then
			g_server:broadcastEvent(scaniaLifterEvent:new(vehicle, id, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(scaniaLifterEvent:new(vehicle, id, state));
		end;
	end;
end;
